#ifndef BNB_H
#define BNB_H

#define bytes(type) (sizeof(type))
#define bits(type) (bytes(type) << (3))

#define LSIZE bytes(long)
#define LBITS bits(long)

#define ISIZE bytes(int)
#define IBITS bits(int)

#define SSIZE bytes(short)
#define SBITS bits(short)

#define CSIZE bytes(char)
#define CBITS bits(char)

#define rightmost(num) ((num) & (1))
#define leftmost(num) ((num) >> (bits(num) - 1))

#define Allones(count) (((unsigned long)~0) >> (LBITS - ((count) + 1)))
#define allones(count) (((1) << (count)) - (1))

#define high(num) ((num) >> (bits(num) >> (1)))
#define low(num) ((num) & (allones(bits(num) >> (1))))

#define test(num,bit) ((num) & ((1) << (bit)))

#define noteq(num1,num2) ((num1) ^ (num2))

#endif
