#include<stdlib.h>
#include<memory.h>
#include<errno.h>

#include"hash.h"
#include"prime.h"

int resize(size_t size,size_t additions,size_t deletions) {
			int diff,newsize;

			diff = additions - deletions;
			if(abs(diff) >= (resizeratio * (size))) {
				newsize = (int) (((double)(size << 1)) * additions / deletions);
			}
			else {
				newsize = -1;
            }
			return newsize;
	   }

table_t hnew(size_t *about,float occupancy) {
			  size_t actual;
			  static table_t new;

			  actual = cprime((int)(((double)*about)/occupancy));
			  if((new = (table_t)calloc(actual,sizeof(element_t))) != NULL) {
				  *about = actual;
              }
			  return new;
	   }

void hdispose(table_t table,size_t size,freee_fn freee) {
                  if(freee == NULL) freee = free;
		  while(size > 0) {
                        --size;
                        if(table[size] != NULL)
                             freee(table[size]);
                             
          }
		  free(table);
	}

int hsearch(table_t table,size_t size,element_t key,hash_fn hash,cmp_fn cmp) {
		 int pos,null,prev;

		 null = -1;
		 prev = -1;
		 hashes = 0;
		 while(((pos = hash(key,size)) >= 0) && ((1 << hashes) <= size)) {
			 ++hashes;
			 if(cmp == NULL) {
				if(table[pos] == NULL) 
				   return pos;
			 }
			 else {
				if(table[pos] != NULL)  {
				   if(! cmp(key,table[pos])) {
						element_t temp = table[pos];
						if(null >= 0) {
							table[pos] = table[null];
							table[null] = temp;
							return null;
						}
						if(prev >= 0) {
							table[pos] = table[prev];
							table[prev] = temp;
							return prev;
						}
						return pos;
				   }
				   if(swapfound == YES && null < 0 && poshash == YES) {
						prev = pos;
				   }
				}
				else {
					if(swapfound == YES && null < 0)
					   null = pos;
				}
			}
        }
		 return -1;
	  }

table_t *hresize(table_t *table,size_t *size,size_t newsize,hash_fn hash,fail_fn fail) {
			  static table_t newtable;
			  bool_t swap;
              int pos;

			  if(newsize != (*size))  {
				  newsize = cprime(newsize);
				  if((newtable = calloc(sizeof(element_t),newsize)) == NULL)
						return NULL;
				  swap = swapfound;
				  swapfound = NO;
				  pos = 0;
				  while(pos <= (*size)) {
					   if((*table)[pos] != NULL) {
						  int newloc = hsearch(newtable,newsize,(*table)[pos],hash,0);
						  if(newloc < 0) {
							   if(fail((*table)[pos])) {
								  errno = EHRESIZEFAIL;
								  swapfound = swap;
								  free(newtable);
								  return NULL;
							   }
						  }
						  else {
							 newtable[newloc] = (*table)[pos];
						  }
					   }
					   pos++;
				  }
				  swapfound = swap;
				  free(*table);
				  *table = newtable;
				  *size = newsize;
			  }
			  return table;
	  }

element_t hget(table_t table,size_t size,get_t get,int *pos) {
				switch(get) {
					case GETLAST :{
									 *pos = size;
                                   }
                    case GETPREV : {
									while(((--(*pos)) >= 0) && (! table[*pos]))
										   ;
									 break;
								  }
					case GETFIRST :{
									*pos = -1;
									}
					case GETNEXT :{
									while(((++(*pos)) < size) && (! table[*pos]))
										  ;
									break;
								  }
					    default : *pos = -1;
				}
			  return (((*pos) < 0) || ((*pos) >= size)) ? NULL : table[*pos];
		  }
