#ifndef HASH_H
#define HASH_H

#ifndef BOOL_T
#define BOOL_T
typedef enum boolean { FALSE, TRUE, NO = 0, YES } bool_t;
#endif

#ifndef _SIZE_T
#define _SIZE_T
typedef int size_t;
#endif

#define RESIZERATIO (.9)
double resizeratio = RESIZERATIO;
int resize(size_t size,size_t additions,size_t deletions);

#ifndef ELEMENT_T
#define ELEMENT_T
typedef void * element_t;
#endif

#ifndef TABLE_T
#define TABLE_T
typedef element_t * table_t;
#endif

typedef int (* hash_fn)(element_t key,size_t size);
typedef int (* cmp_fn)(element_t key,element_t element);
typedef void (* freee_fn)(element_t element);
typedef int (* fail_fn)(element_t element);

table_t hnew(size_t *about,float occupancy);
void hdispose(table_t table,size_t size,freee_fn freee);

int hashes;
bool_t poshash = NO,swapfound = YES;
int hsearch(table_t table,size_t size,element_t key,hash_fn hash,cmp_fn cmp);

#define EHRESIZEFAIL (-1923)
table_t *hresize(table_t *table,size_t *size,size_t newsize,hash_fn hash,fail_fn fail);

#ifndef GET_T
#define GET_T
typedef enum getelement{ GETFIRST, GETNEXT, GETPREV, GETLAST } get_t;
#endif

element_t hget(table_t table,size_t size,get_t get,int *pos);

#include"hash_fn.h"

#endif
