#include"bnb.h"
#include"hash.h"
#include"hash_fn.h"

extern int hashes;

#define CHAR_SHIFT_MAX (LBITS - CBITS + 1)
unsigned long strtohashkey(char *string) {
			unsigned long key = 0;

			while(*string) {
			  key ^= ((unsigned)*string) << (key % CHAR_SHIFT_MAX);
			  string++;
			}
			return key;
	 }

int hash0(element_t key,size_t size) {
	   static unsigned long hkey;
	   static int initial;
	   int pos;

	   if(hashes == 0) {
			 hkey = (hashkey) ? hashkey(key) : *(unsigned long *)key;
			 return pos = initial = hkey % size;
	   }
	   pos = ((hkey + (hashstep * hashes)) % size);
	   return (pos != initial) ? pos : (-1);
	}

int hash1(element_t key,size_t size) {
	   static unsigned long hkey;
	   static int initial,pos;

	   if(hashes == 0) {
			 hkey = (hashkey) ? hashkey(key) : *(unsigned long *)key;
			 return pos = initial = hkey % size;
	   }
	   pos = ((hkey + (hashstep * pos)) % size);
	   return (pos != initial) ? pos : (-1);
	}

int hash2(element_t key,size_t size) {
	   static unsigned long hkey;
	   static int pos,initial,step;

	   if(hashes == 0) {
			 hkey = (hashkey) ? hashkey(key) : *(unsigned long *)key;
			 step = 0;
			 return pos = initial = hkey % size;
	   }
	   step += pos;
	   pos = ((hkey + step) % size);
	   return (pos != initial) ? pos : (-1);
	}

int hash3(element_t key,size_t size) {
	   static unsigned long hkey;
	   static int pos,prev,pprev,step;

	   if(hashes == 0) {
			 hkey = (hashkey) ? hashkey(key) : *(unsigned long *)key;
			 step = 0;
			 pprev = prev = -1;
			 return pos = hkey % size;
	   }
	   step += hashes;
	   pprev = prev;
	   prev = pos;
	   pos = ((hkey + step) % size);
	   return (pos != pprev) ? pos : (-1);
	}

int hash4(element_t key,size_t size) {
	   static unsigned long hkey;
	   static int initial,pos;

	   if(hashes == 0) {
			 hkey = (hashkey) ? hashkey(key) : *(unsigned long *)key;
			 return pos = initial = hkey % size;
	   }
	   pos = ((hkey * (pos + 1)) % size);
	   return (pos != initial) ? pos : (-1);
	}

int hash5(element_t key,size_t size) {
	   static unsigned long hkey;
	   static int pos,initial;

	   if(hashes == 0) {
			 hkey = (hashkey) ? hashkey(key) : *(unsigned long *)key;
			 return pos = initial = hkey % size;
	   }
	   pos = ((hkey + pos) % size);
	   return (pos != initial) ? pos : (-1);
	}

int hash6(element_t key,size_t size) {
	   static unsigned long hkey;
	   static int initial;
	   int pos;

	   if(hashes == 0) {
			 hkey = (hashkey) ? hashkey(key) : *(unsigned long *)key;
			 return pos = initial = hkey % size;
	   }
	   pos = ((hkey * (hashes + 1)) % size);
	   return (pos != initial) ? pos : (-1);
	}

int  phashstep0(int size) {
		int step = 1,shift = size >> 1;

		while(shift > 0) {
			 if(step*step > size) step -= shift;
			 else step += shift;
			 shift >>= 1;
		}
		return step;
	 }

int phash0(element_t key,size_t size) {
	   static unsigned long hkey;
	   static int initial;
	   int pos;

	   if(hashes == 0) {
			 hkey = (hashkey) ? hashkey(key) : *(unsigned long *)key;
			 return pos = initial = hkey % size;
	   }
	   pos = ((pos + 1) * phashstep) % size;
	   return (pos != initial) ? pos : (-1);
	}
